	Options	/Extend

	Integer Function Get_User (username, length, uic, privmask, tty, l_tty,
     &				   job_type, port_name, l_portname)

C   Get the username for this process, and return the privileges that
C   we are installed with.

	Implicit	None
	Character *(*)	username, tty, port_name
	Integer		length, ok, l_tty, job_type, l_portname, uic
	Integer		Sys$Getjpiw
	Integer *4	iosb (2), privmask (2)
	Include		'($JPIDEF)'

	Structure /ITEM_TYPE/
		Integer *2	bufsize
		Integer *2	code
		Integer *4	address
		Integer *4	length
	End Structure

	Record /ITEM_TYPE/	item (7)

C   Populate the item list - we want username

	item (1).bufsize = 12
	item (1).code = Jpi$_Username
	item (1).address = %Loc (username)
	item (1).length = %Loc (length)

C   We also want the image privs

	item (2).bufsize = 8
	item (2).code = Jpi$_Imagpriv
	item (2).address = %Loc (privmask)
	item (2).length = 0

C   Terminal

	item (3).bufsize = Len (tty)
	item (3).code = Jpi$_Terminal
	item (3).address = %Loc (tty)
	item (3).length = %Loc (l_tty)

C   Process Type

	item (4).bufsize = 4
	item (4).code = Jpi$_Mode
	item (4).address = %Loc (job_type)
	item (4).length = 0

C   Port Name

	item (5).bufsize = Len (port_name)
	item (5).code = Jpi$_TT_Accpornam
	item (5).address = %Loc (port_name)
	item (5).length = %Loc (l_portname)

C   UIC

	item (6).bufsize = 4
	item (6).code = JPI$_UIC
	item (6).address = %Loc (uic)
	item (6).length = 0

C   List terminator                      

	item (7).bufsize = 0
	item (7).code = 0

C   Get the information
               
	ok = Sys$Getjpiw (,,, item, iosb,,)
	If (ok) ok = iosb (1)
	Get_User = ok

	End


	Integer Function Get_User_Info (user, enc_pass, salt, algorithm,
     &					min_length, flags)

C   Get information about the user.

	Implicit	None
	Include		'($UAIDEF)'
	Character *(*)	user
	Integer		enc_pass (2), salt, algorithm, min_length, flags
	Integer		Sys$Getuai, ok

	Structure /UAI_TYPE/
		Integer *2	bufsize
		Integer *2	code
		Integer *4	address
		Integer *4	length
	End Structure

	Record	/UAI_TYPE/	item (6)

C   Start loading the item list.

C   The encryption algorithm
                                   
	item (1).bufsize = 1	       	! byte of info
	item (1).code = UAI$_Encrypt
	item (1).address = %Loc (algorithm)
	item (1).length = 0		! not interested

C   User Flags

	item (2).bufsize = 4		! longword
	item (2).code = UAI$_Flags
	item (2).address = %Loc (flags)
	item (2).length = 0

C   The encrypted password

	item (3).bufsize = 8
	item (3).code = UAI$_Pwd
	item (3).address = %Loc (enc_pass)
	item (3).length = 0

C   Minimum password length

	item (4).bufsize = 1
	item (4).code = UAI$_Pwd_Length
	item (4).address = %Loc (min_length)
	item (4).length = 0

C   Encryption algorithm salt

	item (5).bufsize = 2
	item (5).code = UAI$_Salt
	item (5).address = %Loc (salt)
	item (5).length = 0

C   Terminator

	item (6).bufsize = 0
	item (6).code = 0

C   Go get it.

	Call Enable_Privileges
	Get_User_Info = Sys$Getuai (,, user, item,,,)
	Call Disable_Privileges

	End


	Integer Function Check_Old_Password (user, enc_pass, salt,
     &					     algorithm, password)

C   Check the 'password' string to see if it is the same as the encrypted
C   one he has already.

	Implicit	None
	Include		'($SSDEF)'
	Character *(*)	user, password
	Integer		salt, algorithm, test_enc (2), enc_pass (2), dict
	Integer		ok, Sys$Hash_Password

C   Hash the new password

	ok = Sys$Hash_Password (password, %Val (algorithm), %Val (salt),
     &				user, test_enc)

C   If we can't hash, fail safe

	If (.not. ok) go to 100

C   Compare

	If (enc_pass (1) .eq. test_enc (1)
     &		.and. enc_pass (2) .eq. test_enc (2)) then
	   ok = SS$_Normal
	Else
	   ok = SS$_Invlogin
	End If

C   Return result                 

100	Check_Old_Password = ok
	End


	Options	/Extend
                                          
C+
	Integer Function Check_New_Password (password, user, enc_pass, salt,
     &					     algorithm, min_length, flags,
     &						test_enc)

C   Check the new password.  The requirements are:
C		1. Only letters, numbers, $, _
C		2. A length of at least 'min_length'
C		3. It must be different from the old password.
C		4. Not in the dictionary (unless the user is exempted).
C		5. Not in the user's history (unless he is exempted).

	Implicit	None
	Character *(*)	password, user                     
	Character *32	entry_name, username
	Character *64	lpass
	Character *32000 hashwords
	Integer *4	hashword (8000)
	Equivalence	(hashword, hashwords)
	Integer		enc_pass (2), test_enc (2), salt, algorithm, length
	Integer		min_length, flags, dict, iostatus, status, hist
	Integer		n_records, i, l_pass
	Logical		first_time /.true./, ok
	Include		'($UAIDEF)'
	Include		'($FORDEF)'
	Integer		Sys$Hash_Password
	Save		first_time, dict, hist
	External	Cngpass__Cantchange, Cngpass__Genpwd
	External	Cngpass__Tooshort, Cngpass__Internal
	External	Cngpass__indict, Cngpass__Same, Cngpass__Inhist

C  If this is the first time we are called, initialize the unit numbers.

	If (first_time) then
		Call Lib$Get_Lun (dict)
		Call Lib$Get_Lun (hist)
		first_time = .false.
	End If

C  Is the user allowed to change his password ?

	If (Ibits (flags, UAI$V_Lockpwd, 1)) then
		Check_New_Password = %Loc (Cngpass__Cantchange)
		Return
	End If

C  Is he restricted to generated passwords ?   

	If (Ibits (flags, UAI$V_Genpwd, 1)) then         
		Check_New_Password = %Loc (Cngpass__Genpwd)
		Return
	End If

C  Is the new password long enough ?

	If (Len (password) .lt. min_length) then
		Check_New_Password = %Loc (Cngpass__Tooshort)
		Return
	End If

C  See if the new password is the same as the old one.

C  We must hash the new password to compare.

	ok = Sys$Hash_Password (password, %Val (algorithm), %Val (salt),
     &					user, test_enc)

	If (.not. ok) then		! oops
		Check_New_Password = %Loc (Cngpass__Internal)
		Return
	End If

	If (test_enc (1) .eq. enc_pass (1) .and.
     &	    test_enc (2) .eq. enc_pass (2)) then
		Check_New_Password = %Loc (Cngpass__Same)
		Return
	End If

C   Is it in the dictionary ?

	If (.not. Ibits (flags, UAI$V_Dispwddic, 1)) then
		Call Lowercase (password, lpass, l_pass)

C   Open the dictionary file

		Call Enable_Privileges
		Open (dict, name='SYS$SHARE:VMS$PASSWORD_DICTIONARY.DATA',
     &			readonly, shared, iostat=iostatus, status='old',
     &			organization='indexed', access='keyed',
     &			form='unformatted')     
		Call Disable_Privileges

		If (iostatus .ne. 0) go to 80		! I/O error

		Read (dict, key=lpass (1:l_pass), iostat=iostatus) entry_name
                                                      
		If (iostatus .eq. 0) then		! record was found
			Close (dict)
			Check_New_Password = %Loc (Cngpass__indict)
			Return               
		Else				! record not found
			Close (dict)
			Call Errsns (,,,, status)
			If (status .ne. For$_Attreanon) go to 80
		End If

	End If

C   Is it in the history file

	If (.not. Ibits (flags, UAI$V_Dispwdhis, 1)) then

C   Open the history file

	   Call Enable_Privileges
	   Open (hist, name='SYS$SYSTEM:VMS$PASSWORD_HISTORY.DATA',
     &			readonly, shared, iostat=iostatus, status='old',
     &			organization='indexed', access='keyed',
     &			form='formatted')
	   Call Disable_Privileges

	   If (iostatus .ne. 0) go to 80		! I/O error

	   Read (hist, 11, iostat=iostatus) length, username, hashwords
11	   Format (Q, A, A)

	   If (iostatus .eq. 0) then		! record found

C   Work out how many passwords there are (apart from username, divide by 4)

		n_records = (length - 32) / 4
                                            
C   Compare all the passwords in the history to this one.

		Do i = 1, n_records - 3, 4

			If (test_enc (1) .eq. hashword (i) .and.
     &			    test_enc (2) .eq. hashword (i+1)) then
				Check_New_Password = %Loc (Cngpass__Inhist)
				Return
			End If
		End do

	   Else					! record not found
			Close (hist)
			Call Errsns (,,,, status)
			If (status .ne. For$_Attreanon) go to 80
	   End If
	End If

C   Passed all tests.

	Check_New_Password = .true.
	Return

C  I/O error occurred

80	Call ERRSNS (,,,, status)
	Check_New_Password = status
	End


	Integer Function Set_Password (user, password, enc_pass)

C   Set the 'password' for this 'user'.

	Implicit	None
	Character *(*)	user, password
	Integer		Sys$Setuai, ok, Set_History
	Integer *4	enc_pass (2)
	Include		'($UAIDEF)'

	Structure /ITEM_TYPE/                   
		Integer *2	bufsize
		Integer *2	code
		Integer *4	address
		Integer *4	length
	End Structure

	Record /ITEM_TYPE/	item (2)

C   Set up the item list.

	item (1).bufsize = Len (password)
	item (1).code = UAI$_Password
	item (1).address = %Loc (password)
	item (1).length = 0
                                                               
	item (2).bufsize = 0
	item (2).code = 0

C   Set the information

	Call Enable_Privileges
	ok = Sys$Setuai (,, user, item,,,)
	Call Disable_Privileges
	Set_Password = ok

	End


	Integer Function Set_History (user, enc_param, flags)
                                            
C   Add the encrypted password 'enc_pass' to the history record for 'user'.
C   If such a record does not exist, create a new one.  Note that if the
C   user is exempt from history (as set by 'flags') do nothing.

	Implicit	None
	Include		'($UAIDEF)'
	Character *(*)	user
	Character *32032	rec_string
	Integer *4	enc_param (2), enc_pass (2), date_time (2)
	Integer		unit, status, length, flags
	Logical		first_time	/.true./
	Character *8	pass_string, date_string
	Equivalence	(pass_string, enc_pass)
	Equivalence	(date_string, date_time)
	External	Cngpass__Histopen, Cngpass__Histio
	Save		unit, first_time

C   If he is exempt from history do nothing.

	If (Ibits (flags, UAI$V_Dispwdhis, 1)) then
		Set_History = .true.
		Return
	End If

	enc_pass (1) = enc_param (1)
	enc_pass (2) = enc_param (2)

C   Get the unit number

	If (first_time) then                   
		first_time = .false.
		Call Lib$Get_Lun (unit)
	End If

C   Get current time

	Call Sys$Gettim (date_time)

C   Open the history file.                         

	Call Enable_Privileges

	Open (unit, name='SYS$SYSTEM:VMS$PASSWORD_HISTORY.DATA', status='old',
     &		shared, organization='indexed', access='keyed',
     &		recordtype='variable', form='formatted', err=80)

C   Get the record for this user 

	Read (unit, 11, key=user, iostat=status) length, rec_string
11	Format (Q, A)

C   If no record exists, create a new one

	If (status .ne. 0) then
		rec_string = user // pass_string // date_string
		length = Len (user) + Len (pass_string) + Len (date_string)
		Write (unit, 21, err=81) user, pass_string, date_string
C		Write (unit, 21) user, pass_string, date_string
21		Format (3A)
	Else

C   Add the current password and date to the end of the record & rewrite it.

		rec_string = rec_string (1:length) // pass_string // date_string
		length = length + Len (pass_string) + Len (date_string)
C		Rewrite (unit, 22, err=81) rec_string (1:length)
		Rewrite (unit, 22) rec_string (1:length)
22		Format (A)
	End If

	Close (unit)
	Call Disable_Privileges
	Set_History = .true.
	Return

C   Error occurred opening file.

80	Set_History = %Loc (Cngpass__Histopen)
	Return

C   I/O error on history file

81	Close (unit)
	Set_History = %Loc (Cngpass__Histio)
	End


	Subroutine Set_Privilege_Mask (privmask)

C   Stash the 'privmask' in COMMON.  Subsequent calls to turn on/off privs
C   work on this mask.

	Implicit	None
	Integer *4	privmask (2)
	Integer *4	privs (2)
	Common	/PRIV_AREA/	privs

	privs (1) = privmask (1)
	privs (2) = privmask (2)
	End


	Integer Function Enable_Privileges

C   Turn on the privileges specified in the mask.  Return success code to
C   the caller

	Implicit	None
	Integer *4	privs (2)
	Common	/PRIV_AREA/	privs
	Integer		Sys$Setprv, ok

	ok = Sys$Setprv (%Val (1), privs,,)
	If (.not. ok) call Sys$Exit (%Val (ok))

	Enable_Privileges = ok
	End


	Subroutine Disable_Privileges

C   Turn off the privileges specified in the mask.  Unlike the former case,
C   we do care if this operation fails.  If we can't turn off the privs we
C   want, then crash and burn immediately.

	Implicit	None
	Include		'($SSDEF)'
	Integer *4	privs (2)
	Common	/PRIV_AREA/	privs
	Integer		ok, Sys$Setprv

	ok = Sys$Setprv (%Val (0), privs,,)

	If (.not. ok) then
		Call Lib$Signal (ok)
		Call Sys$Exit (%Val (SS$_Abort))
	End If

	End


	Integer Function Check_Identifier (identifier, uic)

C   Check to see if the 'uic' has the identifier 'identifier'.  Return
C   .true. if he has, and an error code if he hasn't

	Implicit	None
	Include		'($SSDEF)'
	Character *(*)	identifier
	Integer		uic, ident, test_ident, ok, context, holder (2)
	Integer		Sys$Asctoid, Sys$Find_Held

C   Convert identifier to numeric form.

	ok = Sys$Asctoid (identifier, test_ident,)

	If (.not. ok) then
		Check_Identifier = ok
		Return
	End If

C   Set up the user descriptor

	holder (1) = uic
	holder (2) = 0

C   Step through the identifiers held by this user.

	context = 0
	ok = Sys$Find_Held (holder, ident,, context)

	Do While (ok)
		If (ident .eq. test_ident) then
			Check_Identifier = .true.
			Return
		End If

		ok = Sys$Find_Held (holder, ident,, context)
	End do

C   We've run out of identifiers

	Check_Identifier = SS$_Nopriv
	End


	Subroutine Lowercase (input, output, length)

C   Convert any uppercase characters in 'input' string to lowercase,
C   returning result in 'output'.

	Implicit	None
	Character *(*)	input, output
	Integer		start, finish, offset, length
	Parameter	(start = (Ichar ('A')))
	Parameter	(finish = (Ichar ('Z')))
	Parameter	(offset = (Ichar ('a') - Ichar ('A')))
	Integer		i, ich
                       
	length = Len (input)

	Do i = 1, length
		ich = Ichar (input (i:i))

		If (ich .ge. start .and. ich .le. finish) then
			ich = ich + offset
			output (i:i) = Char (ich)             
		Else
			output (i:i) = input (i:i)
		End If
	End do

	End
